# Copyright (c) 2000-2005, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}

%define	section		free
%define	milestone	M1

Name:		wadi
Summary:	WADI Application Distribution Infrastructure
Url:		http://wadi.codehaus.org/
Version:	2.0
Release:	0.M1.1jpp
Epoch:		0
License:	Apache Software License 2.0
Group:		Development/Libraries/Java
Vendor:		JPackage Project
Distribution:	JPackage
Source0:	wadi-2.0-M1.tar.gz
# svn export http://svn.codehaus.org/wadi/tags/V2_0M1/wadi/

Source1:        pom-maven2jpp-depcat.xsl
Source2:        pom-maven2jpp-newdepmap.xsl
Source3:        pom-maven2jpp-mapdeps.xsl
Source4:        wadi-2.0-jpp-depmap.xml
Patch0:		wadi-2.0-project_xml.patch
Patch1:		wadi-2.0-DIndex.patch
Patch2:		wadi-2.0-RestartableCluster.patch
Patch3:		wadi-2.0-core-project_xml.patch
Patch4:		wadi-2.0-jetty5-project_xml.patch
Patch5:		wadi-2.0-jgroups-project_xml.patch
Patch6:		wadi-2.0-tomcat55-project_xml.patch
Patch7:		wadi-2.0-TomcatSession.patch
Patch8:		wadi-2.0-webapp-project_xml.patch
Patch9:		wadi-2.0-jboss4-project_xml.patch
Patch10:	wadi-2.0-assembly-project_xml.patch

BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:	junit
BuildRequires:	jmock
BuildRequires:	maven >= 0:1.1
BuildRequires:	saxon
BuildRequires:	saxon-scripts
BuildRequires:	ant
BuildRequires:	junit


BuildRequires:	activecluster
BuildRequires:	activemq3
BuildRequires:	axion
BuildRequires:	concurrent
BuildRequires:	geronimo-j2ee-management-1.0-api
BuildRequires:	geronimo-jms-1.1-api
BuildRequires:	geronimo-jsp-2.0-api
BuildRequires:	geronimo-servlet-2.4-api
BuildRequires:	jakarta-commons-collections
BuildRequires:	jakarta-commons-dbcp
BuildRequires:	jakarta-commons-el
BuildRequires:	jakarta-commons-httpclient
BuildRequires:	jakarta-commons-logging
BuildRequires:	jakarta-commons-pool
BuildRequires:	jakarta-commons-primitives
BuildRequires:	jboss4-common
BuildRequires:	jgroups
BuildRequires:	tomcat5
BuildRequires:	tomcat5-jasper
BuildRequires:	geronimo-jcache-1.0-api
BuildRequires:	mx4j
BuildRequires:	mysql-connector-java
BuildRequires:	jetty5
BuildRequires:	regexp
BuildRequires:	spring-all
BuildRequires:	xerces-j2
BuildRequires:	xml-commons-apis

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif
%if ! %{gcj_support}
BuildArch:      noarch
%endif
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

%description
WADI started life as a solution to the problems surrounding
the distribution of state in clustered web tiers, but is 
becoming a more generalised distributed space service. 
WADI's aim is to resolve many of the problems of dealing 
with state in a cluster. This involves technologies such as : 
WADI Core:
* Vertically - a distributed 'space' with pluggable/stackable 
  paging and persistance mechanisms (File, Database, etc.)
* Horizontally - A scalable, highly available, self-
  partitioning, self-healing clustering substrate - a 
  distributed index/map
* Pessimistic locking semantics
* Transparent State->Invocation and Invocation->State migration
* Under construction - Various replication strategies 
  (including efficient in-vm replication) for HA state
  WADI Web:
* A resolution to application vs container space concurrency
  issues surrounding HttpSessions
* Pluggable HttpSession serialisation strategies - 
  per-session, per-attribute
* HttpRequest relocation (by redirection and proxying)
* Under construction - pluggable HttpSession replication 
  points - immediate, end-of-request-group, timed

  WADI currently supports the following J2EE containers and 
  application servers:
* Tomcat 5.0.18+, 5.5.x
* Jetty 5.1.3+, 6.x
* OpenEJB (underway)
* Axis2 (underway)
* Geronimo-1.0.x/Tomcat or Jetty (underway)
* JBoss-4.x/Tomcat or Jetty


%package core
Summary:	Core Module from %{name}
Group:		Development/Libraries/Java
Requires:	activecluster
Requires:	activemq3-core
Requires:	concurrent
Requires:	geronimo-jcache-1.0-api
Requires:	geronimo-jms-1.1-api
Requires:	geronimo-servlet-2.4-api
Requires:	jakarta-commons-httpclient
Requires:	jakarta-commons-logging
Requires:	mx4j
Requires:	spring-core
Requires:	spring-beans
Requires:	spring-support

%description core
%{summary}.

%package jboss4
Summary:	JBoss4 Module from %{name}
Group:		Development/Libraries/Java
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	jakarta-commons-logging
Requires:	jboss4-common

%description jboss4
%{summary}.

%package jetty5
Summary:	Jetty5 Module from %{name}
Group:		Development/Libraries/Java
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	geronimo-servlet-2.4-api
Requires:	jakarta-commons-logging
Requires:	jetty5

%description jetty5
%{summary}.

%package jgroups
Summary:	JGroups Module from %{name}
Group:		Development/Libraries/Java
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	activecluster
Requires:	concurrent
Requires:	geronimo-jms-1.1-api
Requires:	jgroups

%description jgroups
%{summary}.

%package tomcat55
Summary:	Tomcat55 Module from %{name}
Group:		Development/Libraries/Java
Requires:	%{name}-core = %{epoch}:%{version}-%{release}
Requires:	geronimo-servlet-2.4-api
Requires:	jakarta-commons-logging
Requires:	mx4j
Requires:	tomcat5-server-lib

%description tomcat55
%{summary}.

%package webapp
Summary:	WebApp Module from %{name}
Group:		Development/Libraries/Java
Requires:	%{name}-core = %{epoch}:%{version}-%{release}

%description webapp
%{summary}.


%package javadoc
Summary:	Javadoc for %{name}
Group:		Development/Documentation
Requires(post):   /bin/rm,/bin/ln
Requires(postun): /bin/rm

%description javadoc
%{summary}.

%package manual
Summary:	Documents for %{name}
Group:		Development/Documentation

%description manual
%{summary}.

%prep
%setup -q -n %{name}-%{version}-%{milestone}
chmod -R go=u-w *
for f in $(find . -name "*.jar"); do
  mv $f $f.no
done
# These tests need a jcache impl
rm -rf modules/core/src/test/org/codehaus/wadi/sandbox/jcache


if [ ! -f %{SOURCE4} ]; then
export DEPCAT=$(pwd)/%{name}-%{version}-depcat.new.xml
echo '<?xml version="1.0" standalone="yes"?>' > $DEPCAT
echo '<depset>' >> $DEPCAT
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    /usr/bin/saxon project.xml %{SOURCE1} >> $DEPCAT
    popd
done
echo >> $DEPCAT
echo '</depset>' >> $DEPCAT
/usr/bin/saxon $DEPCAT %{SOURCE2} > %{name}-%{version}-depmap.new.xml
fi

%patch0 -b .sav
%patch1 -b .sav
%patch2 -b .sav
%patch3 -b .sav
%patch4 -b .sav
%patch5 -b .sav
%patch6 -b .sav
%patch7 -b .sav
%patch8 -b .sav
%patch9 -b .sav
%patch10 -b .sav

%build
for p in $(find . -name project.xml); do
    pushd $(dirname $p)
    cp project.xml project.xml.orig
    /usr/bin/saxon -o project.xml project.xml.orig %{SOURCE3} map=%{SOURCE4}
    popd
done

mkdir endorsed
pushd endorsed
ln -sf $(build-classpath xerces-j2)
ln -sf $(build-classpath xml-commons-apis)
popd
sed -e "s|^java\.endorsed\.dirs=.*$|java.endorsed.dirs=$(pwd)/endorsed|" \
    -e 's|maven.junit.fork=true|maven.junit.fork=false|' \
	project.properties > tempf
cp tempf project.properties
export MAVEN_HOME_LOCAL=$(pwd)/.maven
export MAVEN_DOCS_SRC=$(pwd)/xdocs

maven 	-Dmaven.repo.remote=file:/usr/share/maven/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	-Dmaven.docs.src=$MAVEN_DOCS_SRC \
	-Dmaven.multiproject.excludes=modules/assembly/project.xml,modules/jetty6/project.xml,modules/tomcat50/project.xml \
	-Dgoal=jar:install,javadoc:generate,xdoc:transform \
	multiproject:goal

maven 	-Dmaven.repo.remote=file:/usr/share/maven/repository \
	-Dmaven.home.local=$MAVEN_HOME_LOCAL \
	-Dmaven.docs.src=$MAVEN_DOCS_SRC \
	-Dmaven.multiproject.includes=modules/webapp/project.xml \
	-Dgoal=war:install \
	multiproject:goal

%install
rm -rf $RPM_BUILD_ROOT

# jars
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -m 644 modules/core/target/%{name}-core-%{version}-SNAPSHOT.jar \
   $RPM_BUILD_ROOT%{_javadir}/%{name}/core-%{version}.jar
install -m 644 modules/jboss4/target/%{name}-jboss4-%{version}-SNAPSHOT.jar \
   $RPM_BUILD_ROOT%{_javadir}/%{name}/jboss4-%{version}.jar
install -m 644 modules/jetty5/target/%{name}-jetty5-%{version}-SNAPSHOT.jar \
     $RPM_BUILD_ROOT%{_javadir}/%{name}/jetty5-%{version}.jar
install -m 644 modules/jgroups/target/%{name}-jgroups-%{version}-SNAPSHOT.jar \
   $RPM_BUILD_ROOT%{_javadir}/%{name}/jgroups-%{version}.jar
install -m 644 modules/tomcat55/target/%{name}-tomcat55-%{version}-SNAPSHOT.jar \
   $RPM_BUILD_ROOT%{_javadir}/%{name}/tomcat55-%{version}.jar
install -m 644 modules/webapp/target/%{name}-webapp-%{version}-SNAPSHOT.jar \
   $RPM_BUILD_ROOT%{_javadir}/%{name}/webapp-%{version}.jar

(cd $RPM_BUILD_ROOT%{_javadir}/%{name} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed  "s|-%{version}||g"`; done)

install -d -m 755 $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}
install -m 644 modules/webapp/target/%{name}-webapp-%{version}-SNAPSHOT.war \
   $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version}/webapp-%{version}.war
(cd $RPM_BUILD_ROOT%{_datadir}/%{name}-%{version} && for war in *-%{version}.war; do ln -sf ${war} `echo $war| sed  "s|-%{version}||g"`; done)

# javadoc
install -d -m 755 $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
for m in core jboss4 jetty5 jgroups tomcat55; do 
	mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/${m}
	cp -pr modules/${m}/target/docs/apidocs/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}/${m}
done
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# manual
mv DOCS/JK\,\ Session\ Replication_Clustering\,\ SSL\ and\ failover\ in\ Tomcat\ 5.eml DOCS/JK_Session_Replication_Clustering_SSL_and_failover_in_Tomcat_5.eml
install -d -m 755 $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}
cp -pr DOCS/* $RPM_BUILD_ROOT%{_docdir}/%{name}-%{version}


%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}

%postun javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}
fi

%if %{gcj_support}
%post core
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun core
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post jboss4
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun jboss4
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post jetty5
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun jetty5
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post jgroups
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun jgroups
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post tomcat55
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun tomcat55
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post webapp
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun webapp
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files core
%defattr(-,root,root)
%dir %{_javadir}/%{name}
%{_datadir}/%{name}-%{version}
%{_javadir}/%{name}/core-%{version}.jar
%{_javadir}/%{name}/core.jar
%if %{gcj_support}
%attr(-,root,root) %dir %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/core*-%{version}.jar.*
%endif

%files jboss4
%defattr(-,root,root)
%{_javadir}/%{name}/jboss4-%{version}.jar
%{_javadir}/%{name}/jboss4.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/jboss4*-%{version}.jar.*
%endif

%files jetty5
%defattr(-,root,root)
%{_javadir}/%{name}/jetty5-%{version}.jar
%{_javadir}/%{name}/jetty5.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/jetty5*-%{version}.jar.*
%endif

%files jgroups
%defattr(-,root,root)
%{_javadir}/%{name}/jgroups-%{version}.jar
%{_javadir}/%{name}/jgroups.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/jgroups*-%{version}.jar.*
%endif

%files tomcat55
%defattr(-,root,root)
%{_javadir}/%{name}/tomcat55-%{version}.jar
%{_javadir}/%{name}/tomcat55.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/tomcat55*-%{version}.jar.*
%endif

%files webapp
%defattr(-,root,root)
%{_javadir}/%{name}/webapp-%{version}.jar
%{_javadir}/%{name}/webapp.jar
%if %{gcj_support}
%attr(-,root,root) %{_libdir}/gcj/%{name}/webapp*-%{version}.jar.*
%endif
%{_datadir}/%{name}-%{version}/webapp-%{version}.war
%{_datadir}/%{name}-%{version}/webapp.war

%files javadoc
%defattr(-,root,root)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files manual
%defattr(-,root,root)
%doc %{_docdir}/%{name}-%{version}

%changelog
* Mon Nov 27 2006 Ralph Apel <r.apel at r-apel.de> 0:2.0-0.M1.1jpp
- First release
- Add gcj_support option
- Add post/postun Requires for javadoc
